if not SimpleUnitFrames or not SimpleUnitFrames:HasModule("Basics") then return end

local core = SimpleUnitFrames
local L = core.loc.Basics

local basics = core:GetModule("Basics")
local CustomStyles = core:NewModule("CustomStyles")

basics.consoleOptions.style = {
	type = 'group',
	name = "Custom Styles",
	desc = "Custom Styles",
	args = {
		add = {
			type = 'text',
			name = "Add Custom Style",
			desc = "Add Custom Style Description",
			get = false,
			set = function(v) CustomStyles:AddStyle(v) end,
			validate = function(v) return not basics.db.profile.style[v] end,
		},
	}
}

basics.defaultOptions.style = {}

function CustomStyles:AddStyle(styleName, exists)
	if not exists then
		core:Print("Creating new custom style "..styleName)
		basics.db.profile.style[styleName] = "UNSET"
	end
	basics.formatList[#basics.formatList+1] = styleName
	core.consoleOptions.args.style.args[styleName] = {
		type = 'group',
		name = 'Custom Style '..styleName,
		desc = 'Custom Style '..styleName,
		args = {
			set = {
				type = 'text',
				name = "Set Custom Style",
				get = function() return basics.db.profile.style[styleName] end,
				set = function(v)
					basics.db.profile.style[styleName] = v
					basics:Refresh()
				end,
			},
			del = {
				type = 'execute',
				name = "Delete Custom Style",
				desc = "Delete Custom Style Description",
				func = function()
					core:Print("Deleting custom style "..styleName)
					basics.db.profile.style[styleName] = nil
					core.consoleOptions.args.style.args[styleName] = nil
					for k, v in pairs(basics.formatList) do
						if v == styleName then basics.formatList[k] = nil end
					end
					basics:Refresh()
				end,
			},
		}
	}
end

function CustomStyles:OnEnable()
	for styleName in pairs(basics.db.profile.style) do
		self:AddStyle(styleName, true)
	end
end
